require 'sinatra/base'

# NOTE these will have to change when gemified
require_relative 'authentication/helpers'
require_relative 'authentication/validations'
require_relative 'authentication/password'
require_relative 'authentication/cookies'
require_relative 'authentication/identification'
require_relative 'authentication/login_field'
require_relative 'authentication/user'

module Sinatra
    module Authentication
        VERSION = "0.0.1"

        def require_auth(path_prefix)
            before do
                if request.fullpath =~ /^#{path_prefix}/
                    require_auth
                end
            end
        end
    end

    register Authentication
end
