module Sinatra
    module Authentication
        module Helpers
            def require_auth cookies, required_roles = []
                __USER__.user_auth(cookies, required_roles)
            end

            def current_user(finder = lambda { |id| __USER__[id] })
                # Replace this with OttomanORM shit
                # NOTE: not keeping session data
                # @current_user ||= finder.call(session[:user]) if session[:user]
                nil
            end

            # def logged_in?
            #     !!curent_user
            # end

            def ensure_current_user(user)
                halt 404 unless user == current_user
            end

            def logout!
                # NOTE: not keeping session data
                # session.delete(:user)
            end

            def authenticate(opts)
                if user = __USER__.authenticate(opts[:email], opts[:password])
                    user.id
                end
            end

            def __USER__
                settings.login_user_class
            end

            def should_return_to?(path, ignored = settings.ignored_by_return_to)
                !(path =~ ignored)
            end
        end
    end
end
